Std Group: Difference between revisions

From FreeCAD Documentation
(Removed a broken link.)
No edit summary
Line 3: Line 3:
<!--T:19-->
<!--T:19-->
{{Docnav
{{Docnav
|[[Std Part|Part]]
|[[Std_Part|Part]]
|[[PartDesign Body|Create body]]
|[[PartDesign_Body|Create body]]
|[[PartDesign_Workbench|PartDesign]]
|[[PartDesign_Workbench|PartDesign]]
|IconL=Std_Part.svg
|IconL=Std_Part.svg
Line 155: Line 155:
<!--T:20-->
<!--T:20-->
{{Docnav
{{Docnav
|[[Std Part|Part]]
|[[Std_Part|Part]]
|[[PartDesign Body|Create body]]
|[[PartDesign_Body|Create body]]
|[[PartDesign_Workbench|PartDesign]]
|[[PartDesign_Workbench|PartDesign]]
|IconL=Std_Part.svg
|IconL=Std_Part.svg

Revision as of 10:07, 28 November 2020

Std Group

Menu location
Tree view → Right click on the document name → Create group
Workbenches
All
Default shortcut
None
Introduced in version
-
See also
Std Part, Draft SelectGroup, Draft AddToGroup

Description

Std Group (internally called App DocumentObjectGroup) is a general purpose container that allows you to group different types of objects in the tree view, regardless of their data type. It is used as a simple folder to categorize and organize the objects in your model, in order to keep a logical structure. Std Groups may be nested inside other Std Groups.

The Std Group tool is not defined by a particular workbench, but by the base system, thus it is found in the structure toolbar that is available in all workbenches.

To group 3D objects as a single unit, with the intention of creating assemblies, use Std Part instead.

Various elements inside Std Groups in the tree view.

Usage

  1. Click on the name of the document in the tree view, open the context menu (right click), and choose Create group.
  2. Alternatively, press the Group button in the structure toolbar. An empty Group is created.
  3. To add objects to a Group, select them in tree view, and then drag and drop them over the Group.
  4. To remove objects from a Group, drag them out of the Group, and onto the document label at the top of the tree view.

Notes

  • The Group object does not affect the positions in the 3D view of the elements that it contains; it is essentially just a folder that is used to keep the tree view organized.
  • The Group can also be created from the Python console, and sub-classed to create special "groups", as indicated in the Scripting section.

Properties

A Std Group is internally called App DocumentObjectGroup (App::DocumentObjectGroup class), and is derived from the basic App DocumentObject (App::DocumentObject class), therefore it shares all the latter's properties.

In addition to the properties described in App FeaturePython, which is the most basic instance of an App DocumentObject, the App DocumentObjectGroup has the DataGroup property.

These are the properties available in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.

Data

Base

  • DataLabel (String): the user editable name of this object, it is an arbitrary UTF8 string.
  • DataGroup (LinkList): a list of referenced objects. By default, it is empty [].

Hidden properties Data

  • DataProxy (PythonObject): a custom class associated with this object. This only exists for the Python version. See Scripting.

View

Base

See App FeaturePython for the basic view properties.

Hidden properties View

  • ViewProxy (PythonObject): a custom view provider class associated with this object. This only exists for the Python version. See Scripting.

Inheritance

A Std Group is formally an instance of the class App::DocumentObjectGroup, whose parent is the basic App DocumentObject (App::DocumentObject class), and is augmented with a Group extension.

Simplified diagram of the relationships between the core objects in the program. The App::DocumentObjectGroup class is a simple container which uses the Group extension to be able to hold any type of object.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information on adding objects to the document.

A Std Group (App DocumentObjectGroup) is created with the addObject() method of the document. Once a Group exists, other objects can be added to it with the addObject() or addObjects() methods of this Group.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::DocumentObjectGroup", "Group")

bod1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
bod2 = App.ActiveDocument.addObject("Part::Box", "Box")

obj.addObjects([bod1, bod2])
App.ActiveDocument.recompute()

This basic App::DocumentObjectGroup doesn't have a Proxy object so it can't be fully used for sub-classing.

Therefore, for Python subclassing, you should create the App::DocumentObjectGroupPython object.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("App::DocumentObjectGroupPython", "Name")
obj.Label = "Custom label"

For example, a FEM Analysis is an App::DocumentObjectGroupPython object with a custom icon and additional properties.

Links